//
//  AppController.m
//  UpTime
//
//  Created by Milo on 20/06/2007.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "AppController.h"

NSString *MBLongestRecordedUpTime = @"MBLongestRecordedUpTime";
NSString *MBLastTenRecordedUpTimes = @"MBLastTenRecordedUpTimes";


@implementation AppController

- (IBAction)createTime:(id)sender;
{
	NSNumber *currentUpTime = [NSNumber numberWithCurrentUpTime];
	
	if ([self longestRecordedUpTime] == nil || [currentUpTime compare:[self longestRecordedUpTime]] == NSOrderedDescending)
		[self setLongestRecordedUpTime:currentUpTime];
		
	NSMutableArray *lastTenUpTimes = [[self lastTenRecordedUpTimes] mutableCopy];
	if (lastTenUpTimes == nil)
		lastTenUpTimes = [[NSMutableArray alloc] initWithCapacity:10];
	[lastTenUpTimes insertObject:currentUpTime atIndex:0];
	if ([lastTenUpTimes count] > 10)
		[lastTenUpTimes removeLastObject];
	[self setLastTenRecordedUpTimes:lastTenUpTimes];
	[lastTenUpTimes release];
}

- (NSNumber *)longestRecordedUpTime;
{
	return [[NSUserDefaults standardUserDefaults] objectForKey:MBLongestRecordedUpTime];
}

- (void)setLongestRecordedUpTime:(NSNumber *)newUpTime;
{
	[[NSUserDefaults standardUserDefaults] setObject:newUpTime forKey:MBLongestRecordedUpTime];
}

- (NSArray *)lastTenRecordedUpTimes;
{
	return [[NSUserDefaults standardUserDefaults] objectForKey:MBLastTenRecordedUpTimes];
}

- (void)setLastTenRecordedUpTimes:(NSArray *)newUpTimes;
{
	[[NSUserDefaults standardUserDefaults] setObject:newUpTimes forKey:MBLastTenRecordedUpTimes];
}

@end


#pragma mark -
@implementation NSNumber (MBUpTimeAdditions)

+ (id)numberWithCurrentUpTime;
{
	return [self numberWithUnsignedLongLong:UnsignedWideToUInt64(AbsoluteToNanoseconds(UpTime())) / 1000000000];	// UpTime in seconds
}

@end